# Scripts for EDLPortalMeteoData

Retrieve meteo data from edl portal and store values in DMS.    
Possible intervals: hour, day.    
Datapoints are created for every hour/day in furture - configured by duration.

For timestampformat see 
- https://www.geeksforgeeks.org/time-formatting-in-golang/
- https://stackoverflow.com/questions/20234104/how-to-format-current-time-using-a-yyyymmddhhmmss-format
- https://go.dev/src/time/format.go.

See #37322.

---

## Example for user configuration

```json
[
    {
        "dmsPrefix": "PortalMeteoData",
        "edlPortalApiKey": "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
        "meteoDataDefinitions": [
            {
                "duration": 10,
                "edlPortalRds": "METEO:9:RR",
                "interval": "hour"
            },
            {
                "duration": 3,
                "edlPortalRds": "METEO:9:TT",
                "interval": "day"
            }
        ],
        "name": "PortalMeteoData",
        "portalHost": "demo.edl.ch",
        "portalScheme": "https",
        "timestampFormatDay": "02.01.2006",
        "timestampFormatHour": "02.01.2006 15:04"
    }
]
```


