window.ngui(() => {
    return {
        emits: [
            'update:skipComputation'
        ],
        props: [
            'modelValue',            
        ],
        data() {
            return {
            }
        },
        mounted() {
        },
        nodes() {
            return [                                       
                { 
                    type: 'NgFormInput',
                    props: {
                        type: 'checkbox',
                        label: 'renderInChart',
                        col: 12,
                        modelValue: this.modelValue.chartOptions.show,
                        'onUpdate:modelValue': (value) => {
                            this.modelValue.chartOptions.show = value;
                            this.$emit('update:skipComputation', true);
                        },
                    },
                },                
                { 
                    type: 'NgFormInput',
                    props: {
                        type: 'checkbox',
                        label: 'chartCustomYAxis',
                        col: 12,
                        modelValue: this.modelValue.chartOptions.y.ownAxis,
                        'onUpdate:modelValue': (value) => {
                            this.modelValue.chartOptions.y.ownAxis = value;
                            this.$emit('update:skipComputation', true);
                        },
                    },
                },
                { 
                    type: 'NgFormInput',
                    props: {
                        type: 'select',
                        label: 'chartCustomYAxisPosition',
                        col: 12,
                        options: [
                            { label: this.$t('leftSide'), value: false}, 
                            { label: this.$t('rightSide'), value: true}
                        ],
                        modelValue: this.modelValue.chartOptions.y.opposite,
                        'onUpdate:modelValue': (value) => {
                            this.modelValue.chartOptions.y.opposite = value;
                            this.$emit('update:skipComputation', true);
                        },
                    },
                },                                  
                { 
                    type: 'NgFormInput',
                    props: {
                        type: 'number',
                        label: 'min',
                        modelValue: this.modelValue.chartOptions.y.min,
                        col: 6,
                        'onUpdate:modelValue': (value) => {
                            this.modelValue.chartOptions.y.min = value;
                            this.$emit('update:skipComputation', true);
                            if (value === '') {
                                delete this.modelValue.chartOptions.y.min;
                            }
                        },
                    },
                },
                { 
                    type: 'NgFormInput',
                    props: {
                        type: 'number',
                        label: 'max',
                        modelValue: this.modelValue.chartOptions.y.max,
                        col: 6,
                        'onUpdate:modelValue': (value) => {
                            this.modelValue.chartOptions.y.max = value;
                            this.$emit('update:skipComputation', true);
                            if (value === '') {
                                delete this.modelValue.chartOptions.y.max;
                            }
                        },
                    },
                },                
                { 
                    type: 'NgFormInput',
                    props: {
                        type: 'number',
                        label: 'numberDecimal',
                        col: 12,
                        modelValue: this.modelValue.chartOptions.decimal,
                        'onUpdate:modelValue': (value) => {
                            this.modelValue.chartOptions.decimal = value;
                            this.$emit('update:skipComputation', true);
                        },
                        rules: [(val) => val !== '' && val !== undefined || this.$t('ruleNotEmpty')] 
                    },
                },                              
                { 
                    type: 'NgFormInput',
                    props: {
                        type: 'color',
                        label: 'color',
                        col: 12,
                        modelValue: this.modelValue.chartOptions.color,
                        'onUpdate:modelValue': (value) => {
                            this.modelValue.chartOptions.color = value;
                            this.$emit('update:skipComputation', true);
                        },
                        rules: [(val) => val !== '' || this.$t('ruleNotEmpty')] 
                    },
                }                 
            ]
        },
    }
});