// Call ngui function to create a ui config.
window.ngui(() => {
  return {
    
    // The returned object can be accessed with this within any method...
    // Do not use this.ctx within this function because it is not yet created.
    data() {
      return {
        // VAR
        component: null,
      }
    },

    beforeMount() {
      this.fetchComponent()
    },

    watch: {
      '$route.query'(newVal, oldVal){
        if (newVal && newVal.render && oldVal && oldVal.render && newVal.render !== oldVal.render) {
          this.fetchComponent()
        }
      }
    },
    
    methods: {
      async fetchComponent() {
        this.component = null;
        const path = this.$route.query.render
        if (path) {
          this.component = window.nguiAsyncImport(path)
        }
      }
    },
    
    // Define elements within the ui configuration...
    nodes() {
      return [
        // any ui component node can be used...
        window.components.page().append(() => [
          window.components.renderIf(this.component, window.components.element(this.component)),
        ])
      ]
    },
  }
})