// Call ngui function to create a ui config.
window.ngui(() => {
  return {
    
    // The returned object can be accessed with this within any method...
    // Do not use this.ctx within this function because it is not yet created.
    data() {
      return {
        // VAR
        editable: true,
        btnColor: 'amber-9',
      }
    },
    
    // Define elements within the ui configuration...
    nodes() {
      return [
        // any ui component node can be used...
        window.components.page().append(() => [
          window.components.breadcrumbs([
            {
              label: this.$t('settings'),
            }
          ]),
          window.components.bar('settings'),
          window.components.section().append(() => [
            window.components.getButtonsGrid([
              {
                name: 'general',
                description: 'settings',
                to: '/settings/general',
                icon: 'settings',
                color: this.btnColor,
              },
              {
                name: 'server',
                description: 'serverSettingsHint',
                to: '/settings/server',
                icon: 'mdi-server',
                color: this.btnColor,
              },
            ]),
          ])
        ])
      ]
    },
  }
})