// Call ngui function to create a ui config.
window.ngui(() => {
  return {
    
    // The returned object can be accessed with this within any method...
    // Do not use this.ctx within this function because it is not yet created.
    data() {
      return {
        // VAR
        editable: true,
        btnColor: 'grey-6',
      }
    },
    
    // Define elements within the ui configuration...
    nodes() {
      return [
        // any ui component node can be used...
        window.components.page(this.ctx.globals.getPermissions(['usersRead'])).append(() => [
          window.components.breadcrumbs([
            {
              label: this.$t('userManagement'),
            }
          ]),
          window.components.bar('userManagement'),
          window.components.section().append(() => [
            window.components.getButtonsGrid([
              {
                name: 'users',
                description: 'manageUsers',
                to: '/users/users',
                icon: 'person',
                color: this.btnColor,
              },
              {
                name: 'roles',
                description: 'manageRoles',
                to: '/users/roles',
                icon: 'mdi-home-group',
                color: this.btnColor,
              },
              {
                name: 'permissions',
                description: 'managePermissions',
                to: '/users/permissions',
                icon: 'mdi-key',
                color: this.btnColor,
              },
              {
                name: 'policies',
                description: 'managePolicies',
                to: '/users/policies',
                icon: 'mdi-key-link',
                color: this.btnColor,
              },
              {
                name: 'operatingGroups',
                description: 'manageOperatingGroups',
                to: '/users/operatinggroups',
                icon: 'business',
                color: this.btnColor,
              },
              {
                name: 'provider',
                description: 'manageProviders',
                to: '/users/providers',
                icon: 'cloud',
                color: this.btnColor,
              },
              {
                name: 'accessTokens',
                description: 'API',
                to: '/users/access-tokens',
                icon: 'mdi-security',
                color: this.btnColor,
              },
                            {
                name: 'autologin',
                description: 'perApp',
                to: '/users/autologin',
                icon: 'mdi-account-key',
                color: this.btnColor,
              },
            ]),
          ])
        ])
      ]
    },
  }
})