// Call ngui function to create a ui config.
window.ngui(() => {
  return {
    
    // The returned object can be accessed with this within any method...
    // Do not use this.ctx within this function because it is not yet created.
    data() {
      return {
        // VAR
      }
    },
    
    // Define elements within the ui configuration...
    nodes() {
      return [
        // any ui component node can be used...
        window.components.page(this.ctx.globals.getPermissions(['accessTokenRead'])).append(() => [
          window.components.renderIf(!this.$route.query.headless, window.components.breadcrumbs([
            {
              label: this.$t('userManagement'),
              to: '/users'
            },
            {
              label: this.$t('accessTokens'),
              to: '/users/access-tokens'
            }
          ])),
          window.components.renderIf(!this.$route.query.headless, window.components.bar('accessTokens')),
          window.components.section().attrs({ class: 'flex justify-center' }).append(() => [
            window.components.card().attrs({ flat: false, class: 'full-width' }).append(() => [
              window.components.element('NgAccessTokens').attrs({ 
				class: 'q-ma-md',
				permissionsAdd: this.ctx.globals.getPermissions(['accessTokenCreate']),
				permissionsDelete: this.ctx.globals.getPermissions(['accessTokenDelete']),
              }),
            ]),
          ])
        ])
      ]
    },
  }
})