// Call ngui function to create a ui config.
window.ngui(() => {
  return {
    
    // The returned object can be accessed with this within any method...
    // Do not use this.ctx within this function because it is not yet created.
    data() {
      return {
        // VAR
      }
    },
    
    // Define elements within the ui configuration...
    nodes() {
      return [
        // any ui component node can be used...
        window.components.page(this.ctx.globals.getPermissions(['usersRead'])).append(() => [
          window.components.breadcrumbs([
            {
              label: this.$t('userManagement'),
              to: '/users'
            },
            {
              label: this.$t('autologin'),
              to: '/users/autologin'
            }
          ]),
          window.components.bar('autologin'),
          window.components.section().attrs({ class: 'flex justify-center' }).append(() => [
            window.components.card().attrs({ flat: false, style: { maxWidth: '320px' } }).append(() => [
              window.components.element('NgUsersMgmtAutologin').attrs({ class: 'q-ma-md' }),
            ]),
          ])
        ])
      ]
    },
  }
})