// Call ngui function to create a ui config.
window.ngui(() => {
  return {
    props: [
      'object',
      'design',
      'panel',
    ],

    config(){
      return {
        startPanel: 'settings',
        panels: [
          {
            header: 'settings',
            name: 'settings',
            items: [
              {
                type: 'form',
                props: {
                  scope: 'data',
                  showReset: false,
                  schema: [
                    {
                      type: 'dms-path',
                      label: 'path',
                      scope: 'setValueData.link',
                      workspaceUuid: this.ctx.attrs.design.ctx.workspaceUuid,
                      serviceUuids: this.ctx.attrs.design.ctx.serviceUuids,
					  default: {
						processManagerUuid: '',
						instanceUuid: '',
						processUuid: '',
						path: '',
					  },
                      'call.enableTypes': `
                        const types = []
                        if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                          return types
                        }
                        switch(ctx.data.setValueData.attrs.type) {
                          case 'text':
                          case 'password':
                          case 'email':
                          case 'color':
                          case 'phone':
                            types.push('string')
                            break;
                          case 'number':
                            types.push('int', 'int8', 'int16', 'int32', 'double', 'uint', 'uint8', 'uint16', 'uint32')
                            break;
                          case 'toggle':
                            types.push('bool')
                            break;
                        }
                        return types
                      `
                    },
                    {
                      type: 'text',
                      label: 'title',
                      default: 'set',
                      scope: 'setValueData.attrs.title',
					  'call.hidden': `
                        if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                          return true
                        }
                        return ctx.data.setValueData.attrs.isTitleLink === true
                      `,
                    },
					{
                      type: 'dms-path',
					  workspaceUuid: this.ctx.attrs.design.ctx.workspaceUuid,
                      serviceUuids: this.ctx.attrs.design.ctx.serviceUuids,
					  default: {
						processManagerUuid: '',
						instanceUuid: '',
						processUuid: '',
						path: '',
					  },
                      label: 'titlePath',
                      scope: 'setValueData.attrs.titleLink',
                      'call.hidden': `
                        if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                          return true
                        }
                        return ctx.data.setValueData.attrs.isTitleLink === false
                      `,
                    },
                    {
                      type: 'checkbox',
                      scope: 'setValueData.attrs.isTitleLink',
                      label: 'isTitleLink',
                      default: false,
                      col: 'col-12',
                    },
                    {
                      type: 'text',
                      label: 'label',
                      default: 'value',
                      scope: 'setValueData.attrs.label',
                      'call.hidden': `
                        if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                          return true
                        }
                        return ctx.data.setValueData.attrs.isLabelLink === true
                      `,
                    },
                    {
                      type: 'dms-path',
                      label: 'labelPath',
					  workspaceUuid: this.ctx.attrs.design.ctx.workspaceUuid,
                      serviceUuids: this.ctx.attrs.design.ctx.serviceUuids,
					  default: {
						processManagerUuid: '',
						instanceUuid: '',
						processUuid: '',
						path: '',
					  },
                      scope: 'setValueData.attrs.labelLink',
                      'call.hidden': `
                        if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                          return true
                        }
                        return ctx.data.setValueData.attrs.isLabelLink === false
                      `,
                    },
                    {
                      type: 'checkbox',
                      scope: 'setValueData.attrs.isLabelLink',
                      label: 'isLabelLink',
                      default: false,
                      col: 'col-12',
                    },
                    {
                      type: 'text',
                      label: 'submitLabel',
                      default: 'setValue',
                      scope: 'setValueData.attrs.submitLabel',
                      'call.hidden': `
                        if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                          return true
                        }
                        return ['constant'].includes(ctx.data.setValueData.attrs.type) || ctx.data.setValueData.attrs.isSubmitLabelLink === true
                      `,
                    },
                    {
                      type: 'dms-path',
                      label: 'submitLabelPath',
                      workspaceUuid: this.ctx.attrs.design.ctx.workspaceUuid,
                      serviceUuids: this.ctx.attrs.design.ctx.serviceUuids,
					  default: {
						processManagerUuid: '',
						instanceUuid: '',
						processUuid: '',
						path: '',
					  },
                      scope: 'setValueData.attrs.submitLabelLink',
                      'call.hidden': `
                        if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                          return true
                        }
                        return ['constant'].includes(ctx.data.setValueData.attrs.type) || ctx.data.setValueData.attrs.isSubmitLabelLink === false
                      `,
                    },
                    {
                      type: 'checkbox',
                      scope: 'setValueData.attrs.isSubmitLabelLink',
                      label: 'isSubmitLabelLink',
                      default: false,
                      col: 'col-12',
                      'call.hidden': `
                        if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                          return true
                        }
                        return ['constant'].includes(ctx.data.setValueData.attrs.type)
                      `,
                    },
                    {
                      type: 'select',
                      label: 'type',
                      default: '',
                      scope: 'setValueData.attrs.type',
                      options: [
                        { label: 'auto', value: '' },
                        { label: 'text', value: 'text' },
                        { label: 'email', value: 'email' },
                        { label: 'password', value: 'password' },
                        { label: 'color', value: 'color' },
                        { label: 'time', value: 'time' },
                        { label: 'date', value: 'date' },
                        { label: 'date-time', value: 'date-time' },
                        { label: 'number', value: 'number' },
                        { label: 'toggle', value: 'toggle' },
                        { label: 'select', value: 'select' },
                        { label: 'constant', value: 'constant' },
                      ]
                    },
                    {
                      type: 'select',
                      scope: 'setValueData.attrs.constantType',
                      label: 'constantType',
                      default: undefined,
                      'call.hidden': `
                        if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                          return true
                        }
                        return !['toggle', 'constant'].includes(ctx.data.setValueData.attrs.type)
                      `,
                      col: 'col-12',
                      options: [
                        { label: 'none', value: '' },
                        { label: 'string', value: 'text' },
                        { label: 'number', value: 'number' },
                        { label: 'boolean', value: 'checkbox' },
                      ]
                    },
                    {
                      type: 'select',
                      scope: 'setValueData.attrs.constantSetType',
                      label: 'constantSetType',
                      default: 'set',
                      'call.hidden': `
                        if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                          return true
                        }
                        return !['constant'].includes(ctx.data.setValueData.attrs.type) || !['checkbox'].includes(ctx.data.setValueData.attrs.constantType)
                      `,
                      col: 'col-12',
                      options: [
                        { label: 'constSet', value: 'set' },
                        { label: 'reset', value: 'reset' },
                        { label: 'constToggle', value: 'toggle' },
                        { label: 'impulseLongPress', value: 'impulse' },
						{ label: 'positiveImpulse', value: 'positiveImpulse' },
						{ label: 'negativeImpulse', value: 'negativeImpulse' },
                      ]
                    },
                    {
                      type: 'checkbox',
                      scope: 'setValueData.attrs.isConstantLink',
                      label: 'isConstantLink',
                      default: false,
                      'call.hidden': `
                        if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                          return true
                        }
                        return ctx.data.setValueData.attrs.type !== 'constant' || ctx.data.setValueData.attrs.constantType === 'checkbox'
                      `,
                      col: 'col-6',
                    },
					{
                      type: 'checkbox',
                      scope: 'setValueData.attrs.hideConstantDialog',
                      label: 'hideConstantDialog',
                      default: false,
                      'call.hidden': `
                        if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                          return true
                        }
                        return ctx.data.setValueData.attrs.type !== 'constant'
                      `,
                      col: 'col-6',
                    },
                    {
                      scope: 'setValueData.attrs.constantClickValue',
                      label: 'constantValue',
                      default: undefined,
                      'call.type': `return ctx.data.setValueData.attrs.constantType`,
                      'call.hidden': `
                        if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                          return true
                        }
                        return ctx.data.setValueData.attrs.type !== 'constant' || ctx.data.setValueData.attrs.isConstantLink === true || ctx.data.setValueData.attrs.constantType === 'checkbox'
                      `,
                      col: 'col-12',
                    },
                    {
                      type: 'dms-path',
                      label: 'constantPath',
                      workspaceUuid: this.ctx.attrs.design.ctx.workspaceUuid,
                      serviceUuids: this.ctx.attrs.design.ctx.serviceUuids,
					  default: {
						processManagerUuid: '',
						instanceUuid: '',
						processUuid: '',
						path: '',
					  },
                      scope: 'setValueData.attrs.constantClickLink',
                      'call.hidden': `
                        if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                          return true
                        }
                        return ctx.data.setValueData.attrs.type !== 'constant' || ctx.data.setValueData.attrs.isConstantLink === false
                      `,
                    },
                    {
                      scope: 'setValueData.attrs.constantFalseValue',
                      label: 'constantFalseValue',
                      default: false,
                      'call.type': `return ctx.data.setValueData.attrs.constantType`,
                      'call.hidden': `
                        if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                          return true
                        }
                        return ctx.data.setValueData.attrs.type !== 'toggle'
                      `,
                      col: 'col-6',
                    },
                    {
                      scope: 'setValueData.attrs.constantTrueValue',
                      label: 'constantTrueValue',
                      default: true,
                      'call.type': `return ctx.data.setValueData.attrs.constantType`,
                      'call.hidden': `
                        if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                          return true
                        }
                        return ctx.data.setValueData.attrs.type !== 'toggle'
                      `,
                      col: 'col-6',
                    },
                    {
                      type: 'number',
                      scope: 'setValueData.attrs.min',
                      label: 'min',
                      default: undefined,
                      'call.hidden': `
                        if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                          return true
                        }
                        return ctx.data.setValueData.attrs.type !== 'number' || ctx.data.setValueData.attrs.isMinLink === true
                      `,
                      col: 'col-6',
                    },
  				  {
                      type: 'dms-path',
                      label: 'min',
                      workspaceUuid: this.ctx.attrs.design.ctx.workspaceUuid,
                      serviceUuids: this.ctx.attrs.design.ctx.serviceUuids,
					  default: {
						processManagerUuid: '',
						instanceUuid: '',
						processUuid: '',
						path: '',
					  },
                      scope: 'setValueData.attrs.minLink',
                      'call.hidden': `
                        if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                          return true
                        }
                        return ctx.data.setValueData.attrs.type !== 'number' || ctx.data.setValueData.attrs.isMinLink === false
                      `,
  					col: 'col-6',
                    },
  				  {
                      type: 'number',
                      scope: 'setValueData.attrs.max',
                      label: 'max',
                      default: undefined,
                      'call.hidden': `
                        if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                          return true
                        }
                        return ctx.data.setValueData.attrs.type !== 'number' || ctx.data.setValueData.attrs.isMaxLink === true
                      `,
                      col: 'col-6',
                    },
  				  {
                      type: 'dms-path',
                      label: 'max',
                      workspaceUuid: this.ctx.attrs.design.ctx.workspaceUuid,
                      serviceUuids: this.ctx.attrs.design.ctx.serviceUuids,
					  default: {
						processManagerUuid: '',
						instanceUuid: '',
						processUuid: '',
						path: '',
					  },
                      scope: 'setValueData.attrs.maxLink',
                      'call.hidden': `
                        if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                          return true
                        }
                        return ctx.data.setValueData.attrs.type !== 'number' || ctx.data.setValueData.attrs.isMaxLink === false
                      `,
  					col: 'col-6',
                    },
                    {
                      type: 'checkbox',
                      scope: 'setValueData.attrs.isMinLink',
                      label: 'isMinLink',
                      default: false,
  					'call.hidden': `
                        if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                          return true
                        }
                        return ctx.data.setValueData.attrs.type !== 'number'
                      `,
                      col: 'col-6',
                    },
                    {
                      type: 'checkbox',
                      scope: 'setValueData.attrs.isMaxLink',
                      label: 'isMaxLink',
                      default: false,
  					'call.hidden': `
                        if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                          return true
                        }
                        return ctx.data.setValueData.attrs.type !== 'number'
                      `,
                      col: 'col-6',
                    },
                    {
                      type: 'key-value',
                      scope: 'setValueData.attrs.options',
                      label: 'options',
                      keyIdent: 'label',
                      default: [],
                      'call.hidden': `
                        if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                          return true
                        }
                        return ctx.data.setValueData.attrs.type !== 'select'
                      `,
                      schema: [
                        { name: 'label', i18nLabel: 'label', field: 'label' },
                        { name: 'value', i18nLabel: 'value', field: 'value'  },
                      ],
                      col: 'col-12',
                    },
                    {
                      type: 'text',
                      scope: 'setValueData.attrs.format',
                      label: 'format',
                      default: '',
                      'call.hidden': `
                        if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                          return true
                        }
                        return ctx.data.setValueData.attrs.type !== 'date-time' && ctx.data.setValueData.attrs.type !== 'date' && ctx.data.setValueData.attrs.type !== 'time'
                      `,
                      'call.hint': `
                        if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                          return ''
                        }
                        switch (ctx.data.setValueData.attrs.type) {
                          case 'date-time':
                            return 'YYYY-MM-DD HH:mmZ, X (unix)'
                          case 'date':
                            return 'YYYY-MM-DD'
                          case 'time':
                            return 'X (unix), HH:mm:ss, s, ms'
                        }
                        return ''
                      `,
                      col: 'col-6',
                    },
                    {
                      type: 'text',
                      scope: 'setValueData.attrs.mask',
                      label: 'mask',
                      default: '',
                      'call.hidden': `
                        if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                          return true
                        }
                        return ctx.data.setValueData.attrs.type !== 'date-time' && ctx.data.setValueData.attrs.type !== 'date' && ctx.data.setValueData.attrs.type !== 'time'
                      `,
                      'call.hint': `
                        if (!(ctx.data.setValueData && ctx.data.setValueData.attrs)) {
                          return ''
                        }
                        switch (ctx.data.setValueData.attrs.type) {
                          case 'date-time':
                            return 'YYYY-MM-DD HH:mmZ, X (unix)'
                          case 'date':
                            return 'YYYY-MM-DD'
                          case 'time':
                            return 'X (unix), HH:mm:ss, s, ms'
                        }
                        return ''
                      `,
                      col: 'col-6',
                    },
                    {
                      type: 'permissions',
                      default: [],
                      label: 'readPermissions',
                      hint: 'readPermissionsDescription',
                      scope: 'rights.read',
                      col: 'col-12',
                    },
                    {
                      type: 'permissions',
                      default: [],
                      label: 'writePermissions',
                      hint: 'writePermissionsDescription',
                      scope: 'rights.write',
                      col: 'col-12',
                    },
                  ]
                },
              }
            ]
          },
        ]
      }
    },
    
    // The returned object can be accessed with this within any method...
    // Do not use this.ctx within this function because it is not yet created.
    data() {
      return {
        // VAR
		linkObject: null,
		constantClickLink: null,
        computedObject: null,
        linked: false,
        eventValue: null,
		ident: '',
        type: '',
        setType: '',
		constantType: '',
		hideConstantDialog: false,
        constantLinkObject: null,
		titleLinkObject: null,
        labelLinkObject: null,
        submitLabelLinkObject: null,
		maxLinkObject: null,
		minLinkObject: null,
        constantValue: null,
        hold: false,
        holdClick: false,
      }
    },
    
    watch: {
      'object.customData': {
        handler() {
          this.panel.setPermissions(this.object.customData.rights, this.object.customData.setValueData)
        },
        deep: true,
      },
    },
    
    created() {
      this.linked = false;
      // do we handle impulse constant?
      this.hold = this.object.customData.setValueData.attrs.constantSetType === 'impulse' && this.object.customData.setValueData.attrs.constantType === 'checkbox' 
                  && this.object.customData.setValueData.attrs.type === 'constant'
      if (this.object && this.object.customData && this.object.customData.setValueData) {
        if (this.object.customData.setValueData.link && this.object.customData.setValueData.link.processUuid) {
          this.computedObject = this.panel.createComputedObject(this.object.customData.setValueData.link)
		  this.linkObject = this.object.customData.setValueData.link
		  this.ident = `${this.object.customData.setValueData.link.processUuid}:${this.object.customData.setValueData.link.path}`
          // subscribe computed object
          this.panel.on(this.computedObject, '', this.onEvent.bind(this))
          this.linked = true;
          if (this.object.customData.setValueData.attrs.isConstantLink) {
			this.constantClickLink = this.object.customData.setValueData.attrs.constantClickLink;
            this.constantLinkObject = this.panel.createComputedObject(this.constantClickLink)
            this.constantLinkObject.ident = `${this.constantClickLink.processUuid}:${this.constantClickLink.path}`
            this.panel.on(this.constantLinkObject, '', this.onEvent.bind(this))
          } else {
            this.constantValue = this.object.customData.setValueData.attrs.constantClickValue;
          }
		  if (this.object.customData.setValueData.attrs.isTitleLink) {
            const titleLink = this.object.customData.setValueData.attrs.titleLink
            this.titleLinkObject = this.panel.createComputedObject(titleLink)
            this.titleLinkObject.ident = `${titleLink.processUuid}:${titleLink.path}`
            this.panel.on(this.titleLinkObject, '', this.onEvent.bind(this))
          }
          if (this.object.customData.setValueData.attrs.isLabelLink) {
            const labelLink = this.object.customData.setValueData.attrs.labelLink
            this.labelLinkObject = this.panel.createComputedObject(labelLink)
            this.labelLinkObject.ident = `${labelLink.processUuid}:${labelLink.path}`
            this.panel.on(this.labelLinkObject, '', this.onEvent.bind(this))
          }
          if (this.object.customData.setValueData.attrs.isSubmitLabelLink) {
            const submitLabelLink = this.object.customData.setValueData.attrs.submitLabelLink
            this.submitLabelLinkObject = this.panel.createComputedObject(submitLabelLink)
            this.submitLabelLinkObject.ident = `${submitLabelLink.processUuid}:${submitLabelLink.path}`
            this.panel.on(this.submitLabelLinkObject, '', this.onEvent.bind(this))
          }
		  if (this.object.customData.setValueData.attrs.isMaxLink) {
            const maxLink = this.object.customData.setValueData.attrs.maxLink
            this.maxLinkObject = this.panel.createComputedObject(maxLink)
            this.maxLinkObject.ident = `${maxLink.processUuid}:${maxLink.path}`
            this.panel.on(this.maxLinkObject, '', this.onEvent.bind(this))
          }
		  if (this.object.customData.setValueData.attrs.isMinLink) {
            const minLink = this.object.customData.setValueData.attrs.minLink
            this.minLinkObject = this.panel.createComputedObject(minLink)
            this.minLinkObject.ident = `${minLink.processUuid}:${minLink.path}`
            this.panel.on(this.minLinkObject, '', this.onEvent.bind(this))
          }
        }
      }

      if (!this.object.customData.setValueData) {
        this.object.customData.setValueData = {}
      }

      if (!this.object.customData.setValueData.attrs) {
        this.object.customData.setValueData.attrs = {}
      }
	  
	  this.hideConstantDialog = this.object.customData.setValueData.attrs.hideConstantDialog || false
      this.type = this.object.customData.setValueData.attrs.type || ''
      this.setType = this.object.customData.setValueData.attrs.constantSetType || ''
	  this.constantType = this.object.customData.setValueData.attrs.constantType || ''
      this.panel.setPermissions(this.object.customData.rights, this.object.customData.setValueData)
    },
	
	mounted() {
		if (this.hideConstantDialog && this.type === 'constant') {
			this.onSubmitConstantCloseDialog();
		}
	},

    // Listen on unmounted event...
    unmounted() {
      if (this.computedObject) {
        this.panel.off(this.computedObject, '', this.onEvent.bind(this))
      }

      if (this.constantLinkObject) {
        this.panel.off(this.constantLinkObject, '', this.onEvent.bind(this))
      }
	  
	  if (this.titleLinkObject) {
        this.panel.off(this.titleLinkObject, '', this.onEvent.bind(this))
      }

      if (this.labelLinkObject) {
        this.panel.off(this.labelLinkObject, '', this.onEvent.bind(this))
      }

      if (this.submitLabelLinkObject) {
        this.panel.off(this.submitLabelLinkObject, '', this.onEvent.bind(this))
      }
	  
	  if (this.maxLinkObject) {
        this.panel.off(this.maxLinkObject, '', this.onEvent.bind(this))
      }
	  
	  if (this.minLinkObject) {
        this.panel.off(this.minLinkObject, '', this.onEvent.bind(this))
      }
    },

    methods: {
      onPublish(newValue) {
        const path = this.computedObject.getPath();
        this.panel.emit(this.computedObject, {
          set: [
            {
              path,
              value: newValue,
            }
          ]
        });
      },
	  
	  onSubmitConstantCloseDialog() {
		if (this.constantType === 'checkbox') {
			this.panel.emitBoolConstantType(this.linkObject, this.setType)
		} else {
		  this.panel.emitSetByLinkAutoFill(this.linkObject, this.constantClickLink, {
			path: this.linkObject.path,
			value: this.constantValue,
		  })
		}
	
		this.panel.emitTopic('close:dialog:setValue');
      },
	  
	  onSubmit(newValue) {
        this.onPublish(newValue);
		this.panel.emitTopic('close:dialog:setValue');
      },

      /**
       * This method is called when a event for the link is received.
       **/
      onEvent(ev) {
        // Get value from event
        const path = ev.payload.path
        const processUuid = ev.processUuid
        const ident = `${processUuid}:${path}`
		
        if (this.constantLinkObject) {
          if (this.constantLinkObject.ident === ident) {
            this.constantValue = ev.payload.value;
          }
        }
		
		if (this.titleLinkObject) {
          if (this.titleLinkObject.ident === ident) {
            this.object.customData.setValueData.attrs.title = ev.payload.value;
          }
        }

        if (this.labelLinkObject) {
          if (this.labelLinkObject.ident === ident) {
            this.object.customData.setValueData.attrs.label = ev.payload.value;
          }
        }

        if (this.submitLabelLinkObject) {
          if (this.submitLabelLinkObject.ident === ident) {
            this.object.customData.setValueData.attrs.submitLabel = ev.payload.value;
          }
        }
		
		if (this.maxLinkObject) {
          if (this.maxLinkObject.ident === ident) {
            this.object.customData.setValueData.attrs.max = ev.payload.value;
          }
        }
		
		if (this.minLinkObject) {
          if (this.minLinkObject.ident === ident) {
            this.object.customData.setValueData.attrs.min = ev.payload.value;
          }
        }
        
		if (this.ident == ident) {
			const evValue = this.panel.getEventValue(ev)
			const formType = this.getFormType();
			if (this.eventValue !== evValue) {
				this.eventValue = evValue;
			}
			if (this.type !== formType) {
			  this.type = formType
			}
		}
      },

      getFormType() {
        if (this.object && this.object.customData && this.object.customData.setValueData && this.object.customData.setValueData.attrs) {
          if (this.object.customData.setValueData.attrs.type) {
            return this.object.customData.setValueData.attrs.type;
          }
        }
        switch (typeof this.eventValue) {
          case 'string':
            return 'text';
          case 'number':
            return 'number';
          case 'boolean':
            return 'toggle';
        }

        return 'text';
      }
    },

    // Define elements within the ui configuration...
    nodes() {
      if (!this.linked) {
        return [{
          type: 'NgBanner',
          props: {
            text: 'notLinked',
            color: 'warning',
            textColor: 'white',
            icon: 'warning',
            iconColor: 'white',
          },
        }]
      }
      
      return [
        // any ui component node can be used...
        {
          type: this.type === 'constant' ? 'div' : 'NgForm',
          props: {
            column: true,
            onSubmit: () => this.onSubmit(this.eventValue),
            submitLabel: this.object.customData.setValueData.attrs.submitLabel ? this.object.customData.setValueData.attrs.submitLabel : 'setValue',
          },
          children: {
            default: () => {
              return [
                // child nodes or string content
                {
                  type: this.type === 'constant' ? 'NgActionButton' : 'NgFormInput',
                  props: {
                    ...this.object.customData.setValueData.attrs,
                    trueValue: this.object.customData.setValueData.attrs.constantTrueValue,
                    falseValue: this.object.customData.setValueData.attrs.constantFalseValue,
                    type: this.type,
                    hold: this.hold,
                    holdTimeout: 100,
                    modelValue: this.eventValue,
                    fullWidth: true,
                    'onUpdate:modelValue': (val) => {
                      this.eventValue = val
                    },
                    'onHold:stop': () => {
                      // impulse activate
                      if (this.holdClick) {
                        this.holdClick = false;
                        this.onPublish(false);
                      }
                    },
                    'onHold:start': () => {
                      // impulse deactivate
                      if (!this.holdClick) {
                        this.holdClick = true;
                        this.onPublish(true);
                      }
                    },
                    'onBlur': () => {
                      if (this.type !== 'constant') {
                        this.onPublish(this.eventValue);
                      }
                    },
                    'onClick': () => {
                      if (this.type === 'constant' && this.hold === false) {
						if (this.constantType === 'checkbox') {
							switch (this.setType) {
							  case 'set':
								this.onPublish(true);
								break;
							  case 'reset':
								this.onPublish(false);
								break;
							  case 'positiveImpulse':
								this.onPublish(false);
								this.onPublish(true);
								this.onPublish(false);
								break;
							  case 'negativeImpulse':
								this.onPublish(true);
								this.onPublish(false);
								this.onPublish(true);
								break;
							  case 'toggle':
								this.onPublish(!this.eventValue);
								break;
							  default:
								this.onPublish(this.constantValue);
							}
						} else {
							this.onPublish(this.constantValue);
						}
                      }
                    },
                  },
                },
              ]
            }
          },
        },
      ]
    },
  }
})