// Call ngui function to create a ui config.
window.ngui(() => {
  return {
    props: [
      'design',
	  'serviceUuids',
      'item',
      'computedObject',
      'panel',
    ],

    icon: 'mdi-checkbox-blank',
    
    config: {
      startPanel: 'properties',
      panels: [
        {
          header: 'properties',
          name: 'properties',
          items: [
            {
              type: 'form',
              props: {
                scope: 'data',
                schema: [
                  {
                    type: 'checkbox',
                    default: false,
                    label: 'hidden',
                    scope: 'attrs.hidden',
                    col: 'col-12',
                    sideSlot: 'link',
                  },
                  {
                    type: 'dms-path',
                    default: {
                      processManagerUuid: '',
                      instanceUuid: '',
                      processUuid: '',
                      path: '',
                      linkType: 'template',
                    },
                    useLinkType: true,
                    defaultType: 'template',
                    disableLinkTypes: ['none'],
                    'call.disableLinkTypes': 'ctx.attrs.template === undefined ? ["none", "template"] : ["none"]',
                    'call.templateConfig': 'ctx.attrs.template ? ctx.attrs.template.template : undefined',
                    'call.workspaceUuid': 'ctx.props.workspaceUuid',
                    'call.serviceUuids': 'ctx.props.serviceUuids',
                    label: '',
                    scope: 'link',
                    hint: '',
                    col: 'col-12',
                  },
                  {
                    type: 'text',
                    default: '',
                    label: 'label',
                    scope: 'attrs.label',
                    col: 'col-12',
                    sideSlot: 'link',
                  },
                  {
                    type: 'checkbox',
                    default: true,
                    label: 'rounded',
                    scope: 'attrs.rounded',
                    col: 'col-12',
                    sideSlot: 'link',
                  },
                  {
                    type: 'color-palette',
                    default: 'green',
                    label: 'trueColor',
                    scope: 'attrs.trueColor',
                    col: 'col-12',
                    sideSlot: 'link',
                  },
                  {
                    type: 'color-palette',
                    default: 'grey',
                    label: 'falseColor',
                    scope: 'attrs.falseColor',
                    col: 'col-12',
                    sideSlot: 'link',
                  },
                  {
                    type: 'permissions',
                    default: [],
                    label: 'readPermissions',
                    hint: 'readPermissionsDescription',
                    scope: 'rights.read',
                    col: 'col-12',
                  },
                ]
              },
            }
          ]
        }
      ]
    },
    
    // The returned object can be accessed with this within any method...
    // Do not use this.ctx within this function because it is not yet created.
    data() {
      return {
        // VAR
        value: false,
        label: this.item.attrs.label || 'value',
        roundedSquare: 'fas fa-square',
        square: 'fas fa-square-full',
      }
    },
    watch: {
      'item.attrs': {
        handler() {
          this.panel.setPermissions(this.item.rights, this.item)
        },
        deep: true,
      },
    },
    created() {
      this.item.valueType = 'checkbox'
    },
    
    // Listen on mounted event...
    mounted() {
      // logic
      this.panel.on(this.computedObject, '', this.onEvent)
      this.panel.setPermissions(this.item.rights, this.item)

    },
	
      // Listen on mounted event...
    unmounted() {
      // logic
      this.panel.off(this.computedObject, '', this.onEvent)

    },
	
    methods: {
      onEvent(ev) {
        const value = this.panel.getEventValue(ev)
        this.value = value;
      },
    },
	
    // Define elements within the ui configuration...
    nodes() {
      return [
        // any ui component node can be used...
        {
          type: 'div',
          props: {
            ...this.item.attrs,
            class: 'row justify-start items-center q-col-gutter-sm',
          },
          children: {
            default: () => [
              {
                type: 'NgIcon',
                props: {
                  name: this.item.attrs.rounded ? this.roundedSquare : this.square,
                  color: this.value ? this.item.attrs.trueColor : this.item.attrs.falseColor,
                  class: 'q-ml-md',
                },
              },
              {
                type: 'NgText',
                props: {
                  text: this.item.attrs.label || this.label,
                },
              },
            ]
          }
        },
      ]
    },
  }
})