// Call ngui function to create a ui config.
window.ngui(() => {
  return {
    props: [
      'markdown',
      'design',
      'item',
      'computedObject',
      'panel',
      'parent',
    ],

    icon: 'mdi-tab',

    size: 12,
    
    config: {
      startPanel: 'properties',
      panels: [
        {
          header: 'properties',
          name: 'properties',
          items: [
            {
              type: 'form',
              props: {
                scope: 'data',
                schema: [
                  {
                    type: 'checkbox',
                    default: false,
                    label: 'hidden',
                    scope: 'attrs.hidden',
                    col: 'col-12',
                    sideSlot: 'link',
                  },
                  {
                    type: 'checkbox',
                    default: true,
                    label: 'stroke',
                    scope: 'attrs.bordered',
                    col: 'col-12',
                    sideSlot: 'link',
                  },
                  {
                    type: 'checkbox',
                    default: true,
                    label: 'flat',
                    scope: 'attrs.flat',
                    col: 'col-12',
                    sideSlot: 'link',
                  },
                  {
                    type: 'text',
                    default: '',
                    label: 'panel',
                    scope: 'attrs.panelKey',
                    hint: 'dragPanelIntoInput',
                    col: 'col-12',
                    dataTransferTypeKey: 'type',
                    dataTransferType: 'panels',
                    dataTransferValueKey: 'ident',
                    sideSlot: 'link',
                  },
                  {
                    type: 'permissions',
                    default: [],
                    label: 'readPermissions',
                    hint: 'readPermissionsDescription',
                    scope: 'rights.read',
                    col: 'col-12',
                  },
                ]
              },
            }
          ]
        }
      ]
    },	
	
    // The returned object can be accessed with this within any method...
    // Do not use this.ctx within this function because it is not yet created.
    data() {
      return {
        // VAR
        tab: '',
      }
    },
    watch: {
      'item.attrs': {
        handler() {
          this.panel.setPermissions(this.item.rights, this.item)
        },
        deep: true,
      },
    },  
    // Listen on mounted event...
    mounted() {
    },
	
    // Listen on mounted event...
    unmounted() {
      // logic
    },
	
    methods: {

    },
	
    // Define elements within the ui configuration...
    nodes() {

      if (!this.item.attrs.panelKey) {
        return [
          {
            type: 'NgSpinner',
            props: {
              label: 'noData',
              icon: 'cube',
            },
          }
        ]
      }
      
      return [
        // any ui component node can be used...
                {
          type: 'NgCard',
          props: {
            ...( this.item.attrs || {}),
            
          },
          children: {
            default: () => {
              return [
                // child nodes or string content
                {
                  type: 'NgCardSection',
                  props: {

                  },
                  children: {
                    default: () => {
                      return [
                        // child nodes or string content
                        {
                          type: 'NgDesignTemplatePanel',
                          props: {
                            ...(this.item.attrs || {}),
                            design: this.design,
                            template: this.parent.panelData.ctx.template,
                            dialog: false,
                            card: true,
                            activeTab: this.tab,
                            disable: true,
                            nested: true,
                            'onUpdate:tab': (tab) => this.tab = tab,
                            class: 'full-width',
                          },
                        },
                      ]
                    }
                  },
                },
              ]
            }
          },
        },
      ]
    },
  }
})